var CollectionPaginator = /** @class */ (function () {
    function CollectionPaginator(connector, type, options, mfilter) {
        this.connector = connector;
        this.type = type;
        this.options = options;
        this.mfilter = mfilter;
        this._filter = {};
        this.hasNextPage = false;
        this.hasPreviousPage = false;
        this._page = options.page;
        this._offset = options.offset;
        this._range = options.range;
        this._urlExtension = options.urlExtension;
        this._filter = mfilter;
        this._orderOptions = options.orderOptions;
    }
    Object.defineProperty(CollectionPaginator.prototype, "filter", {
        get: function () {
            return this._filter;
        },
        set: function (value) {
            this._filter = value;
            this.reload();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CollectionPaginator.prototype, "page", {
        get: function () {
            return this._page;
        },
        set: function (value) {
            this._page = value;
            this.reload();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CollectionPaginator.prototype, "offset", {
        get: function () {
            return this._offset;
        },
        set: function (value) {
            this._offset = value;
            this.reload();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CollectionPaginator.prototype, "range", {
        get: function () {
            return this._range;
        },
        set: function (value) {
            this._range = value;
            this.reload();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CollectionPaginator.prototype, "urlExtension", {
        get: function () {
            return this._urlExtension;
        },
        set: function (value) {
            this._urlExtension = value;
            this.reload();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CollectionPaginator.prototype, "orderOptions", {
        get: function () {
            return this._orderOptions;
        },
        set: function (value) {
            this._orderOptions = value;
            this.reload();
        },
        enumerable: true,
        configurable: true
    });
    CollectionPaginator.prototype.updateCount = function (count) {
        this.count = count;
        if (this._range > 0) {
            this.hasPreviousPage = this._page > 1;
            this.hasNextPage = Math.ceil(count / this._range) > this._page;
        }
    };
    CollectionPaginator.prototype.reload = function () {
        this.connector.paginatedLoadCollectionExec(this.type, this._filter, this);
    };
    return CollectionPaginator;
}());
export { CollectionPaginator };
//# sourceMappingURL=collection-paginator.class.js.map