import { ExternalInterface } from "../abstract-external-interface.class";
import { CordovaLocalConfiguration } from "./cordova-local-configuration.interface";
import { DataConnector } from "../../data-connector.class";
import { CollectionDataSet, EntityDataSet, FilterData } from "../../types";
import { Observable } from "rxjs/Rx";
export declare class CordovaLocal extends ExternalInterface {
    private configuration;
    private connector;
    private interfaceName;
    fileSystem: any;
    private dataStore;
    constructor(configuration: CordovaLocalConfiguration, connector: DataConnector, interfaceName: string);
    private createFile(dirEntry, fileName, text, isAppend, success, fail);
    private writeFile(fileEntry, dataObj, success, fail);
    private readFile(fileEntry, success, fail);
    private createFileInPersistentStorage(fileName, textContent, success, fail);
    private createFileInSpace(space, fileName, textContent, success, fail);
    private readFileInPersistentStorage(fileName, success, fail);
    private readFileInAppDirectory(fileName, success, fail);
    authenticate(): Observable<EntityDataSet>;
    readonly authenticated: Observable<EntityDataSet>;
    private readEndpoint(endpointName, success, fail);
    private saveToEndPoint(endpointName, content, success, fail);
    private readFileInSpace(space, fileName, success, fail);
    private getCollectionFromStore(type, filter, callback);
    private getEntityFromStore(type, id, callback);
    private deleteEntityFromStore(type, id, callback);
    /**
     * Get last used id from localStorage
     * @returns {number} The value
     */
    private lastUsedId;
    private savePointToStorage(type);
    private loadPointFromStorage(pointName, success);
    private loadPointFromStorageIfEmpty(type, success);
    loadEntity(type: string, id: number): Observable<EntityDataSet>;
    loadCollection(type: string, filter?: FilterData): Observable<CollectionDataSet>;
    saveEntity(entity: EntityDataSet, type: string, id: number): Observable<EntityDataSet>;
    createEntity(type: string, data: EntityDataSet): Observable<EntityDataSet>;
    deleteEntity(type: string, id: number): Observable<boolean>;
    private setEntityInStore(type, id, data);
}
