var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ExternalInterface } from "../abstract-external-interface.class";
import { ReplaySubject } from "rxjs/Rx";
var CordovaLocal = /** @class */ (function (_super) {
    __extends(CordovaLocal, _super);
    function CordovaLocal(configuration, connector, interfaceName) {
        var _this = _super.call(this) || this;
        _this.configuration = configuration;
        _this.connector = connector;
        _this.interfaceName = interfaceName;
        _this.dataStore = {};
        return _this;
        //this.loadPointFromStorage("ideaswall");
    }
    CordovaLocal.prototype.createFile = function (dirEntry, fileName, text, isAppend, success, fail) {
        var _this = this;
        dirEntry.getFile(fileName, { create: true, exclusive: false }, function (fileEntry) {
            _this.writeFile(fileEntry, text, function (e) {
                success(e);
            }, function (e) { return fail(e); });
        }, function (e) {
            fail(e);
        });
    };
    CordovaLocal.prototype.writeFile = function (fileEntry, dataObj, success, fail) {
        fileEntry.createWriter(function (fileWriter) {
            fileWriter.onwriteend = function () {
                success();
            };
            fileWriter.onerror = function (e) {
                fail(e);
            };
            fileWriter.write(dataObj);
        });
    };
    CordovaLocal.prototype.readFile = function (fileEntry, success, fail) {
        fileEntry.file(function (file) {
            var reader = new FileReader();
            reader.onloadend = function () {
                success(this.result);
            };
            reader.readAsText(file);
        }, function (e) {
            fail(e);
        });
    };
    CordovaLocal.prototype.createFileInPersistentStorage = function (fileName, textContent, success, fail) {
        this.createFileInSpace("persistent", fileName, textContent, success, fail);
    };
    CordovaLocal.prototype.createFileInSpace = function (space, fileName, textContent, success, fail) {
        var _this = this;
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function () {
            window.resolveLocalFileSystemURL("cdvfile://localhost/" + space + "/", function (dirEntry) {
                _this.createFile(dirEntry, fileName, textContent, false, function (e) {
                    success(e);
                }, function (e) { return fail(e); });
            }, function (e) {
                fail(e);
            });
        }, function (e) {
            fail(e);
        });
    };
    CordovaLocal.prototype.readFileInPersistentStorage = function (fileName, success, fail) {
        this.readFileInSpace("persistent", fileName, success, fail);
    };
    CordovaLocal.prototype.readFileInAppDirectory = function (fileName, success, fail) {
        var space;
        if (device.platform === "Android") {
            space = "assets";
        }
        else if (device.platform === "iOS") {
            space = "bundle";
        }
        this.readFileInSpace(space, fileName, success, fail);
    };
    CordovaLocal.prototype.authenticate = function () {
        var obs = new ReplaySubject(1);
        /*obs.next({
            "id":"5",
            "label":"christophe",
            "role":[2,3],
            "email":"christophe.vimbert@tralalere.com",
            "you_are":null,
            "type":null,
            "contact_email":null,
            "find_us":null,
            "email_status":null,
            "newsletter":false,
            "picture":"https:\/\/preprod.lms.tralalere.com\/assets\/images\/avatars\/profile.jpg",
            "access":"1543576103",
            "groups":["234","270","271"]
        });*/
        return obs;
    };
    Object.defineProperty(CordovaLocal.prototype, "authenticated", {
        get: function () {
            var obs = new ReplaySubject(1);
            /*obs.next({
                "id":"5",
                "label":"christophe",
                "role":[2,3],
                "email":"christophe.vimbert@tralalere.com",
                "you_are":null,
                "type":null,
                "contact_email":null,
                "find_us":null,
                "email_status":null,
                "newsletter":false,
                "picture":"https:\/\/preprod.lms.tralalere.com\/assets\/images\/avatars\/profile.jpg",
                "access":"1543576103",
                "groups":["234","270","271"]
            });*/
            return obs;
        },
        enumerable: true,
        configurable: true
    });
    CordovaLocal.prototype.readEndpoint = function (endpointName, success, fail) {
        // si le fichier n'existe pas dans le dossier de stockage, on copie celui qui se trouve dans le dossier de l'appli
        // sinon on lit celui-ci
        var _this = this;
        this.readFileInPersistentStorage(endpointName + ".json", function (text) {
            success(text);
            console.log("Fichier lu depuis persistant");
        }, function (e) {
            // le fichier doit être copié dans le stockage persistant
            _this.readFileInAppDirectory("www/assets/endpoints/" + endpointName + ".json", function (oText) {
                /*const cdata: Object = JSON.parse(oText);
                let newObj: Object = {};

                cdata["data"].forEach(elem => {
                    newObj[elem["id"]] = elem;
                });

                oText = JSON.stringify({
                    data: newObj
                });*/
                _this.createFileInPersistentStorage(endpointName + ".json", oText, function () {
                    success(oText);
                    console.log("Fichier copié dans persistant");
                }, function () {
                    console.log("erreur de copie dans le dossier");
                });
            }, function (e) {
                console.log("Erreur bizarre", e);
            });
        });
    };
    CordovaLocal.prototype.saveToEndPoint = function (endpointName, content, success, fail) {
        this.createFileInPersistentStorage(endpointName + ".json", content, function () {
            success();
        }, function (e) {
            fail(e);
        });
    };
    CordovaLocal.prototype.readFileInSpace = function (space, fileName, success, fail) {
        var _this = this;
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function () {
            window.resolveLocalFileSystemURL("cdvfile://localhost/" + space + "/" + fileName, function (fileEntry) {
                _this.readFile(fileEntry, function (text) { return success(text); }, function (e) { return fail(e); });
            }, function (e) {
                fail(e);
            });
        }, function (e) {
            fail(e);
        });
    };
    CordovaLocal.prototype.getCollectionFromStore = function (type, filter, callback) {
        var _this = this;
        if (filter === void 0) { filter = {}; }
        var pointName = type;
        this.loadPointFromStorageIfEmpty(type, function () {
            var dataSet = {};
            var obj = {};
            /*if (Array.isArray(this.dataStore[pointName])) {
                this.dataStore[pointName].forEach(elem => {
                    obj[elem["id"]] = elem;
                });*/
            //} else {
            obj = _this.dataStore[pointName];
            //}
            var keys = Object.keys(obj);
            var filterKeys = Object.keys(filter);
            keys.forEach(function (key) {
                var matching = true;
                filterKeys.forEach(function (filterKey) {
                    if (filter[filterKey] !== obj[+key][filterKey]) {
                        matching = false;
                    }
                });
                if (matching) {
                    dataSet[+key] = obj[+key];
                }
            });
            callback(dataSet);
        });
    };
    CordovaLocal.prototype.getEntityFromStore = function (type, id, callback) {
        var _this = this;
        var pointName = type;
        this.loadPointFromStorageIfEmpty(type, function () {
            callback(_this.dataStore[pointName][String(id)]);
        });
    };
    CordovaLocal.prototype.deleteEntityFromStore = function (type, id, callback) {
        var _this = this;
        var pointName = type;
        this.loadPointFromStorageIfEmpty(type, function () {
            if (_this.dataStore[pointName][String(id)]) {
                delete _this.dataStore[pointName][String(id)];
                _this.savePointToStorage(type);
                return true;
            }
            callback(false);
        });
    };
    Object.defineProperty(CordovaLocal.prototype, "lastUsedId", {
        /**
         * Get last used id from localStorage
         * @returns {number} The value
         */
        // TODO
        get: function () {
            var lastUsedIdKey = "lastusedid";
            if (localStorage[lastUsedIdKey] === undefined || localStorage[lastUsedIdKey] === "") {
                return 0;
            }
            else {
                return +localStorage[lastUsedIdKey];
            }
        },
        // TODO
        set: function (value) {
            var lastUsedIdKey = "lastusedid";
            localStorage[lastUsedIdKey] = value;
        },
        enumerable: true,
        configurable: true
    });
    CordovaLocal.prototype.savePointToStorage = function (type) {
        var pointName = type;
        console.log("77", this.dataStore[pointName]);
        if (this.dataStore[pointName]) {
            var tobj = {};
            for (var key in this.dataStore[pointName]) {
                if (this.dataStore[pointName].hasOwnProperty(key)) {
                    tobj[key] = this.dataStore[pointName][key];
                }
            }
            var obj = {
                data: tobj
            };
            var str = JSON.stringify(obj);
            console.log("save point ts", str, obj);
            this.saveToEndPoint(type, str, function () {
                console.log("Succès de l'enregistrement du endpoint");
            }, function () {
                console.log("Echec de l'enregistrement du endpoint");
            });
        }
    };
    CordovaLocal.prototype.loadPointFromStorage = function (pointName, success) {
        var _this = this;
        console.log("3");
        this.readEndpoint(pointName, function (text) {
            console.log(JSON.parse(text));
            _this.dataStore[pointName] = JSON.parse(text)["data"];
            success();
        }, function () {
            _this.dataStore[pointName] = {};
        });
    };
    CordovaLocal.prototype.loadPointFromStorageIfEmpty = function (type, success) {
        var pointName = type;
        console.log("2");
        if (!this.dataStore[pointName]) {
            this.loadPointFromStorage(pointName, function () {
                success();
            });
        }
        else {
            success();
        }
    };
    CordovaLocal.prototype.loadEntity = function (type, id) {
        var _this = this;
        var subject = new ReplaySubject(1);
        this.loadPointFromStorageIfEmpty(type, function () {
            _this.getEntityFromStore(type, id, function (data) {
                subject.next(data ? data : null);
            });
        });
        return subject;
    };
    CordovaLocal.prototype.loadCollection = function (type, filter) {
        var _this = this;
        if (filter === void 0) { filter = {}; }
        var subject = new ReplaySubject(1);
        this.loadPointFromStorageIfEmpty(type, function () {
            console.log("1");
            _this.getCollectionFromStore(type, filter, function (data) {
                console.log("1b", data);
                subject.next(data ? data : null);
            });
        });
        return subject;
    };
    CordovaLocal.prototype.saveEntity = function (entity, type, id) {
        var _this = this;
        var subject = new ReplaySubject(1);
        console.log("save", entity);
        this.loadPointFromStorageIfEmpty(type, function () {
            _this.setEntityInStore(type, id, entity);
            subject.next(entity);
        });
        return subject;
    };
    CordovaLocal.prototype.createEntity = function (type, data) {
        var subject = new ReplaySubject(1);
        console.log("5", data);
        var newId = ++this.lastUsedId;
        data.id = newId;
        this.setEntityInStore(type, newId, data);
        subject.next(data);
        return subject;
    };
    CordovaLocal.prototype.deleteEntity = function (type, id) {
        var _this = this;
        var subject = new ReplaySubject(1);
        this.loadPointFromStorageIfEmpty(type, function () {
            _this.deleteEntityFromStore(type, id, function (val) {
                subject.next(val);
            });
        });
        return subject;
    };
    CordovaLocal.prototype.setEntityInStore = function (type, id, data) {
        var _this = this;
        var pointName = type;
        console.log("set entity in store");
        this.loadPointFromStorageIfEmpty(type, function () {
            if (!_this.dataStore[pointName]) {
                _this.dataStore[pointName] = {};
            }
            console.log("set 2", data);
            _this.dataStore[pointName][String(id)] = data;
            console.log("dts", _this.dataStore[pointName]);
            _this.savePointToStorage(type);
        });
    };
    return CordovaLocal;
}(ExternalInterface));
export { CordovaLocal };
//# sourceMappingURL=cordova-local.class.js.map